/* Example 10-1.c */

#include <stdio.h>

#define DIV10(A)    ( ! ((A) % 10) ? 1 : 0 )

#define is_digit(c) ('0' <= (c) && (c) <= '9') * 1
#define is_hex(c)   (is_digit(c) || \
                    ('a' <= (c) && (c) <= 'f') || \
                    ('A' <= (c) && (c) <= 'F')) * 1
#define swap(a,b)   { int temp; temp = a; a = b; b = temp; }


int main()
{
    int x, y, z;
    char test_chars[] = { 'A', '4', 'e', '0', 'z', 'G' };

    for (x = 0; x < 20; x++)
        printf("%2d - %d\n", x, DIV10(x));


    for (x = 0; x < sizeof(test_chars) / sizeof(char); x++)
        printf("'%c' -- is_digit=%d  -- is_hex=%d\n",
            test_chars[x], is_digit(test_chars[x]), is_hex(test_chars[x]) );

    y = 1;
    z = 2;

    printf ("y = %d    z = %d\n", y, z);
    swap(y,z);
    printf ("y = %d    z = %d\n", y, z);

    return (0);
}
